import math

def Newton( f, df, c, Lb, Ub ):
    x1 = Lb + 0.3 * (Ub - Lb)
    x0 = Lb + 0.6 * (Ub - Lb)
    while ((abs(x1 - x0) > (1.0e-14) * (abs(x1) + abs(x0)))
           and
           ((abs(x1) + abs(x0)) > 1.0e-14)):
        x0 = x1
        x1 = x0 + (c - f.v(x0)) / df.v(x0)

    return x1    


class Func:
    def __init__(self, a):
        self.a = a

    def v(self, x):
        return pow(x, self.a)

class DFunc:
    def __init__(self, a):
        self.a = a

    def v(self, x):
        return self.a * pow(x, self.a - 1.0)


f = Func(2.0)
df = DFunc(2.0)
v = Newton( f, df, 2.0, 0.0, 10.0 )
print (v)
print (math.sqrt(2.0))

