
def bisect( f, c, Lb, Ub ):
    s = 1.0 if f.v(Ub) > f.v(Lb) else -1.0      #   s = 1 when f.v(x) is an increasing functin
    while ((abs(Ub - Lb) > (1.0e-15) * (abs(Ub) + abs(Lb)))
        and
          (abs(Ub) + abs(Lb) > 1.0e-14)):
              m = 0.5 * (Ub + Lb)
              if (s * (f.v(m) - c)) > 0.0:
                  Ub = m
              else:
                  Lb = m

    return 0.5 * (Ub + Lb)


class Func:
    def __init__(self, a):
        self.a = a

    def v( self, x ):
        return pow(x, self.a)

f = Func(2.0)                   #   f(x) = x ** 2.0
bs = bisect( f, 4.0, 0.0, 5.0 )
print(bs)
bs = bisect( f, 4.0, -5.0, 0.0 )
print(bs)
f = Func(0.5)                   #   f(x) = x ** 0.5
bs = bisect( f, 3.0, 0.0, 10.0 )
print(bs)
    

